# x

<p>
  <picture>
    <source media="(prefers-color-scheme: light)" srcset="https://user-images.githubusercontent.com/25087/236529178-465e9b98-3401-47dd-8691-ea475d96c3ad.png" height="200" />
    <source media="(prefers-color-scheme: dark)" srcset="https://user-images.githubusercontent.com/25087/236529273-6f8c841f-f11b-4ec8-b01d-7e3d9b17c85f.png" height="200" />
    <img src="https://user-images.githubusercontent.com/25087/236529178-465e9b98-3401-47dd-8691-ea475d96c3ad.png" height="200" alt="A 3D rendering of an X"/>
  </picture>
  <br><a href="https://pkg.go.dev/github.com/charmbracelet/x?tab=doc"><img src="https://godoc.org/github.com/golang/gddo?status.svg" alt="Go Docs"></a>
  <a href="https://github.com/charmbracelet/x/actions"><img src="https://github.com/charmbracelet/x/workflows/build/badge.svg" alt="Build Status"></a>
</p>

This repository contains packages that are experimental and that we don’t
promise any backwards compatibility. Once they mature here, they might be moved
into other repositories.

Currently the following packages are available:

- [`ansi`](./ansi): ANSI escape sequence parser and definitions
- [`conpty`](./conpty): Windows Console Pseudo-terminal library
- [`editor`](./editor): open files in text editors
- [`errors`](./errors): `errors.Join` in older Go versions
- [`golden`](./exp/golden): verify golden files equality
- [`higherorder`](./exp/higherorder): generic higher order functions
- [`input`](./input): terminal event input handler and driver
- [`open`](./exp/open): open a file/URL using `open`, `xdg-open`, etc
- [`ordered`](./exp/ordered): generic `min`, `max`, and `clamp` functions for ordered types
- [`slice`](./exp/slice): generic slice utilities
- [`strings`](./exp/strings): utilities for working with strings
- [`teatest`](./exp/teatest): a library for testing [Bubble Tea](https://github.com/charmbracelet/bubbletea) programs
- [`term`](./term): terminal utilities and helpers
- [`termios`](./termios): Termios unified API and library
- [`windows`](./windows): Windows API used at Charmbracelet
- [`xpty`](./xpty): cross-platform PTY interface

## Feedback

We'd love to hear your thoughts on this project. Feel free to drop us a note!

- [Twitter](https://twitter.com/charmcli)
- [The Fediverse](https://mastodon.social/@charmcli)
- [Discord](https://charm.sh/chat)

## License

[MIT](https://github.com/charmbracelet/x/raw/main/LICENSE)

---

Part of [Charm](https://charm.sh).

<a href="https://charm.sh/"><img alt="The Charm logo" src="https://stuff.charm.sh/charm-badge.jpg" width="400"></a>

Charm热爱开源 • Charm loves open source • نحنُ نحب المصادر المفتوحة
